#include<iostream>
#include<fstream>
#include<string>
#include<stdlib.h>
#include<stdio.h>
#include"TFile.h"
#include"TTree.h"
using namespace std;

void txt2root_v5(string filenamein = "test.txt", 
                 string filenameout = "test.root"){

	ifstream in;
	in.open(filenamein);

	string bankHeader("--- Header Bank");
	string endBankHeader("--- End of Header");
	string userHeaderbank("--- User Header Bank");
	string endUserHeaderbank("--- End of User Header");
	string RFSignalsBank("--- RF Signals Bank");
	string endRFSignalsBank("--- End of RF");
	string fluxHeader("--- flux");
	string genParticlesBank("--- Generated Particles Bank");
	string endGenParticlesBank("--- End of Generated");
	string endEvent("---- End of Event");
	string str_ft("--- ft");
	string evn_flag("evn:");

	string aline;
	string str_evn;
	char *token;
	char sss[5000000];
	cout<<aline.max_size()<<endl;
	int ncount;

	vector<long> evn;
	vector<long> pid;
	vector<double> x;
	vector<double> y;
	vector<double> z;
	vector<double> t;
	vector<double> Edep;
	vector<double> Etrk;
	evn.resize(1000000);
	pid.resize(1000000);
	x.resize(1000000);
	y.resize(1000000);
	z.resize(1000000);
	t.resize(1000000);
	Edep.resize(1000000);
	Etrk.resize(1000000);

	//// create output file and TTree
	TFile fout(filenameout.c_str(),"recreate");
	TTree * tree = new TTree("tree","gemc ALERT flux hits");
	tree->Branch("evn",&evn);
	tree->Branch("pid",&pid);
	tree->Branch("x",&x);
	tree->Branch("y",&y);
	tree->Branch("z",&z);
	tree->Branch("t",&t);
	tree->Branch("Edep",&Edep);
	tree->Branch("Etrk",&Etrk);


	//// start to parse the input file
	while(getline(in, aline)){

		evn.clear();
		pid.clear();
		x.clear();
		y.clear();
		z.clear();
		t.clear();
		Edep.clear();
		Etrk.clear();

		//// parse headers
		if(aline.compare(1,15,bankHeader)==0){
			while(1){getline(in, aline);cout<<aline<<endl;
				if(aline.compare(14,4,evn_flag)==0)str_evn=aline;
				if(aline.compare(1,17,endBankHeader)==0)break;
			}
		}else continue;

		getline(in, aline);
		cout<<aline<<endl;
		if(aline.compare(1,20,userHeaderbank)==0){
			while(1){getline(in, aline); if(aline.compare(1,22,endUserHeaderbank)==0)break;}
		}else break;

		getline(in, aline);
		///parse the flux hit informations
		if(aline.compare(1,8,fluxHeader)==0){

			cout<<str_evn<<endl;
			strcpy(sss, str_evn.c_str());
			token = strtok(sss, " -:,\t");
			token = strtok(NULL, " :,\t");
			token = strtok(NULL, " :,\t");
			token = strtok(NULL, " :,\t");
			evn.push_back(atoi(token));

			getline(in, aline);
			getline(in, aline);
			cout<<aline<<endl;
			strcpy(sss, aline.c_str());
			token = strtok(sss, " :,\t");
			ncount = 0;
			while (token != NULL)
			{
				ncount++;
				//pid.push_back(atoi(token));
				if(ncount>4)pid.push_back(atoi(token));
				token = strtok (NULL, " :,\t");
	  		}

			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			strcpy(sss, aline.c_str());
			token = strtok(sss, " :,\t");
			ncount = 0;
			while (token != NULL)
			{
				ncount++;
				//pid.push_back(atoi(token));
				if(ncount>4)Etrk.push_back(atof(token));cout<<token<<endl;
				token = strtok (NULL, " :,\t");
	  		}

			getline(in, aline);	cout<<aline<<endl;
			strcpy(sss, aline.c_str());
			token = strtok(sss, " :,\t");
			ncount = 0;
			while (token != NULL)
	  		{
				ncount++;
				//pid.push_back(atoi(token));
				if(ncount>4)Edep.push_back(atof(token));cout<<token<<endl;
				token = strtok (NULL, " :,\t");
	  		}
			getline(in, aline);	cout<<aline<<endl;
			strcpy(sss, aline.c_str());
			token = strtok(sss, " :,\t");
			ncount = 0;
			while (token != NULL)
	  		{
				ncount++;
				//pid.push_back(atoi(token));
				if(ncount>4)x.push_back(atof(token));
				token = strtok (NULL, " :,\t");
			}

			getline(in, aline);
			cout<<aline<<endl;
			strcpy(sss, aline.c_str());
			token = strtok(sss, " :,\t");
			ncount = 0;
			while (token != NULL)
			{
				ncount++;
				//pid.push_back(atoi(token));
				if(ncount>4)y.push_back(atof(token));
				token = strtok (NULL, " :,\t");
	  		}
			getline(in, aline);
			cout<<aline<<endl;
			strcpy(sss, aline.c_str());
			token = strtok(sss, " :,\t");
			ncount = 0;
			while (token != NULL)
			{
				ncount++;
				//pid.push_back(atoi(token));
				if(ncount>4)z.push_back(atof(token));
				token = strtok (NULL, " :,\t");
	  		}
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;

			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			getline(in, aline);	cout<<aline<<endl;
			strcpy(sss, aline.c_str());
			token = strtok(sss, " :,\t");
			ncount = 0;
			while (token != NULL)
			{
				ncount++;
				//pid.push_back(atoi(token));
				if(ncount>4)t.push_back(atof(token));
				token = strtok (NULL, " :,\t");
			}

		//	getline(in, aline);	cout<<aline<<endl;
		//	getline(in, aline);	cout<<aline<<endl;
		//	getline(in, aline);	cout<<aline<<endl;

			///// read the lines to the end of the event
			while(1){getline(in, aline); if(aline.compare(1,17,endEvent)==0)break;}

			cout<<evn.at(0)<<"\t"<<x.at(0)<<"\t"<<t.at(0)<<endl;
			tree->Fill();

		}/// end parsing the flux hit
		else { while(1){getline(in, aline);if(aline.compare(1,20,endGenParticlesBank)==0)break; if(aline.compare(1,17,endEvent)==0)break;}    }



	}//// end the loop of the file



	//// save the event infos into root file
	// and close the output file
	tree->Write();
	fout.Close();
}
